//+------------------------------------------------------------------+
//|                                                    aedu-.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Yellow  

#property indicator_color4  DodgerBlue  
#property indicator_color5  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  2
#property indicator_width5  2

extern int PERIOD = 15;
extern double Variator =1000000;
extern int Shift = 0;
extern double DegradationHL = 1;
extern double DegradationM = 2;

double  buf_up[], buf_dn[], buf_sum[],ExtMapBuffer2[],ExtMapBuffer1[];

int init() {
  IndicatorDigits(Digits);  
  SetIndexBuffer(0, buf_up);
  SetIndexBuffer(1, buf_dn);
  SetIndexBuffer(2, buf_sum);
  
  SetIndexBuffer(3,ExtMapBuffer2);
  SetIndexBuffer(4,ExtMapBuffer1);
  SetIndexStyle(0, DRAW_LINE);
  SetIndexShift(0,Shift);
  SetIndexStyle(1, DRAW_LINE);
  SetIndexShift(1,Shift);
  SetIndexStyle(2, DRAW_LINE);
  
  SetIndexStyle(3,DRAW_ARROW);
  SetIndexArrow(3,233);
  SetIndexStyle(4,DRAW_ARROW);
  SetIndexArrow(4,234);
  SetIndexEmptyValue(0, -1);
  SetIndexEmptyValue(1, -1);
  SetIndexEmptyValue(2, -1);
  
  SetIndexEmptyValue(3,0.0);
  SetIndexEmptyValue(4,0.0); 
  SetIndexLabel(1, "BAY");     
   
   SetIndexLabel(0, "SELL");
   return(0);
  }  
   int deinit()
  {
//----
   for(int i = 0; i < ObjectsTotal(); i++)
     {
       if(StringFind(ObjectName(i), "txt_", 0) == 0)
         {
           ObjectDelete(ObjectName(i));
           i--;
         }
     }
//----
   return(0);
  }
   int start() {
   
   int   limit,counted_bars=IndicatorCounted();
   double  u, d, s ;
     double spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;//
     if(counted_bars > 0)
	    {
	      counted_bars--;
	    }	
	  limit = Bars - counted_bars;
     
   for(int i = 0; i <= limit; i++) {
   u = iCustom(NULL, 0,"aedu-sil 2", PERIOD, 0, i) ;//
   d = iCustom(NULL, 0,"aedu-sil 2", PERIOD, 1, i) ;//  
   s = iCustom(NULL, 0,"aedu-sil 2", PERIOD, 2, i) ;//
   buf_up[i] = (High[i]+Close[i])/2 +MathAbs(u)/Variator+spread/DegradationHL;
   buf_dn[i] = (Low[i]+Close[i])/2 -MathAbs(d)/Variator-spread/DegradationHL;
   
   if(s > 0 ){
   double Signal_Sell = buf_dn[i]+(buf_up[i]- buf_dn[i])*(MathAbs(s)+MathAbs(d))/(MathAbs (u)+ MathAbs(d))-spread/DegradationM; 
   buf_sum[i]=Signal_Sell;}
   if(s < 0 ){ 
   double Signal_Bay = buf_up[i]-(buf_up[i]- buf_dn[i])*(MathAbs(s)+MathAbs(u))/( MathAbs(d)+ MathAbs(u))+spread/DegradationM ;
   buf_sum[i]=Signal_Bay;}
 
  
    
  if((buf_sum[i]<=buf_dn[i]&& buf_sum[i-1]>buf_dn[i-1]&&Close[i]<Open[i])||(buf_sum[i] < buf_sum[i-1] && buf_sum[i]< buf_dn[i]  ) )
  { 
     ExtMapBuffer2[i] = Low[i] - iATR(NULL, 0, 14, i);       
  
  }
  if((buf_sum[i]>= buf_up[i]&&buf_sum[i-1]< buf_up[i-1]&&Close[i]>Open[i])||(buf_sum[i] > buf_sum[i-1] && buf_sum[i]> buf_up[i]  ) )
                    
     ExtMapBuffer1[i] = High[i] + iATR(NULL, 0, 14, i);            
  
  }
   return(0);
  }